searchNodes=[{"doc":"Nx library extension for digital signal processing.","ref":"NxSignal.html","title":"NxSignal","type":"module"},{"doc":"Returns a tensor of K windows of length N Options :window_length - the number of samples in a window :stride - The number of samples to skip between windows. Defaults to 1 . :padding - A can be :reflect or a valid padding as per Nx.pad/3 over the input tensor's shape. Defaults to :valid . If :reflect or :zeros , the first window will be centered at the start of the signal. For :reflect , each incomplete window will be reflected as if it was periodic (see examples for as_windowed/2 ). For :zeros , each incomplete window will be zero-padded. Examples iex&gt; NxSignal . as_windowed ( Nx . tensor ( [ 0 , 1 , 2 , 3 , 4 , 10 , 11 , 12 ] ) , window_length : 4 ) # Nx.Tensor &lt; s64 [ 5 ] [ 4 ] [ [ 0 , 1 , 2 , 3 ] , [ 1 , 2 , 3 , 4 ] , [ 2 , 3 , 4 , 10 ] , [ 3 , 4 , 10 , 11 ] , [ 4 , 10 , 11 , 12 ] ] &gt; iex&gt; NxSignal . as_windowed ( Nx . tensor ( [ 0 , 1 , 2 , 3 , 4 , 10 , 11 , 12 ] ) , window_length : 3 ) # Nx.Tensor &lt; s64 [ 6 ] [ 3 ] [ [ 0 , 1 , 2 ] , [ 1 , 2 , 3 ] , [ 2 , 3 , 4 ] , [ 3 , 4 , 10 ] , [ 4 , 10 , 11 ] , [ 10 , 11 , 12 ] ] &gt; iex&gt; NxSignal . as_windowed ( Nx . tensor ( [ 0 , 1 , 2 , 3 , 4 , 10 , 11 ] ) , window_length : 2 , stride : 2 , padding : [ { 0 , 3 } ] ) # Nx.Tensor &lt; s64 [ 5 ] [ 2 ] [ [ 0 , 1 ] , [ 2 , 3 ] , [ 4 , 10 ] , [ 11 , 0 ] , [ 0 , 0 ] ] &gt; iex&gt; t = Nx . iota ( { 7 } ) ; iex&gt; NxSignal . as_windowed ( t , window_length : 6 , padding : :reflect , stride : 1 ) # Nx.Tensor &lt; s64 [ 7 ] [ 6 ] [ [ 1 , 2 , 1 , 0 , 1 , 2 ] , [ 2 , 1 , 0 , 1 , 2 , 3 ] , [ 1 , 0 , 1 , 2 , 3 , 4 ] , [ 0 , 1 , 2 , 3 , 4 , 5 ] , [ 1 , 2 , 3 , 4 , 5 , 6 ] , [ 2 , 3 , 4 , 5 , 6 , 5 ] , [ 3 , 4 , 5 , 6 , 5 , 4 ] ] &gt; iex&gt; NxSignal . as_windowed ( Nx . iota ( { 10 } ) , window_length : 6 , padding : :reflect , stride : 2 ) # Nx.Tensor &lt; s64 [ 5 ] [ 6 ] [ [ 1 , 2 , 1 , 0 , 1 , 2 ] , [ 1 , 0 , 1 , 2 , 3 , 4 ] , [ 1 , 2 , 3 , 4 , 5 , 6 ] , [ 3 , 4 , 5 , 6 , 7 , 8 ] , [ 5 , 6 , 7 , 8 , 9 , 8 ] ] &gt;","ref":"NxSignal.html#as_windowed/2","title":"NxSignal.as_windowed/2","type":"function"},{"doc":"Computes the frequency bins for a FFT with given options. Arguments sampling_rate - Sampling frequency in Hz. Options :fft_length - Number of FFT frequency bins. :type - Optional output type. Defaults to {:f, 32} :name - Optional axis name for the tensor. Defaults to :frequencies Examples iex&gt; NxSignal . fft_frequencies ( 1.6e4 , fft_length : 10 ) # Nx.Tensor &lt; f32 [ frequencies : 10 ] [ 0.0 , 1.6e3 , 3.2e3 , 4.8e3 , 6.4e3 , 8.0e3 , 9.6e3 , 1.12e4 , 1.28e4 , 1.44e4 ] &gt;","ref":"NxSignal.html#fft_frequencies/2","title":"NxSignal.fft_frequencies/2","type":"function"},{"doc":"Computes the Inverse Short-Time Fourier Transform of a tensor. Returns a tensor of M time-domain frames of length fft_length . See also: NxSignal.Windows , stft/3 Options :fft_length - the DFT length that will be passed to Nx.fft/2 . Defaults to :power_of_two . :overlap_length - the number of samples for the overlap between frames. Defaults to half the window size. :sampling_rate - the sampling rate $F_s$ in Hz. Defaults to 1000 . :scaling - nil , :spectrum or :psd . :spectrum - each frame is multiplied by $\\sum_{i} window[i]$. nil - No scaling is applied. :psd - each frame is multiplied by $\\sqrt{F_s\\sum_{i} window[i]^2}$. Examples In general, istft/3 takes in the same parameters and window as the stft/3 that generated the spectrum. In the first example, we can notice that the reconstruction is mostly perfect, aside from the first sample. This is because the Hann window only ensures perfect reconstruction in overlapping regions, so the edges of the signal end up being distorted. iex&gt; t = Nx . tensor ( [ 10 , 10 , 1 , 0 , 10 , 10 , 2 , 20 ] ) iex&gt; w = NxSignal.Windows . hann ( n : 4 ) iex&gt; opts = [ sampling_rate : 1 , fft_length : 4 ] iex&gt; { z , _time , _freqs } = NxSignal . stft ( t , w , opts ) iex&gt; result = NxSignal . istft ( z , w , opts ) iex&gt; Nx . as_type ( result , Nx . type ( t ) ) # Nx.Tensor &lt; s64 [ 8 ] [ 0 , 10 , 1 , 0 , 10 , 10 , 2 , 20 ] &gt; Different scaling options are available (see stft/3 for a more detailed explanation). For perfect reconstruction, you want to use the same scaling as the STFT: iex&gt; t = Nx . tensor ( [ 10 , 10 , 1 , 0 , 10 , 10 , 2 , 20 ] ) iex&gt; w = NxSignal.Windows . hann ( n : 4 ) iex&gt; opts = [ scaling : :spectrum , sampling_rate : 1 , fft_length : 4 ] iex&gt; { z , _time , _freqs } = NxSignal . stft ( t , w , opts ) iex&gt; result = NxSignal . istft ( z , w , opts ) iex&gt; Nx . as_type ( result , Nx . type ( t ) ) # Nx.Tensor &lt; s64 [ 8 ] [ 0 , 10 , 1 , 0 , 10 , 10 , 2 , 20 ] &gt; iex&gt; t = Nx . tensor ( [ 10 , 10 , 1 , 0 , 10 , 10 , 2 , 20 ] , type : :f32 ) iex&gt; w = NxSignal.Windows . hann ( n : 4 ) iex&gt; opts = [ scaling : :psd , sampling_rate : 1 , fft_length : 4 ] iex&gt; { z , _time , _freqs } = NxSignal . stft ( t , w , opts ) iex&gt; result = NxSignal . istft ( z , w , opts ) iex&gt; Nx . as_type ( result , Nx . type ( t ) ) # Nx.Tensor &lt; f32 [ 8 ] [ 0.0 , 10.0 , 0.9999999403953552 , - 2.1900146407460852e-7 , 10.0 , 10.0 , 2.000000238418579 , 20.0 ] &gt;","ref":"NxSignal.html#istft/3","title":"NxSignal.istft/3","type":"function"},{"doc":"Generates weights for converting an STFT representation into MEL-scale. See also: stft/3 , istft/3 , stft_to_mel/3 Arguments fft_length - Number of FFT bins mel_bins - Number of target MEL bins sampling_rate - Sampling frequency in Hz Options :max_mel - the pitch for the last MEL bin before log scaling. Defaults to 3016 :mel_frequency_spacing - the distance in Hz between two MEL bins before log scaling. Defaults to 66.6 :type - Target output type. Defaults to {:f, 32} Examples iex&gt; NxSignal . mel_filters ( 10 , 5 , 8.0e3 ) # Nx.Tensor &lt; f32 [ mels : 5 ] [ frequencies : 10 ] [ [ 0.0 , 8.129207999445498e-4 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 ] , [ 0.0 , 9.972016559913754e-4 , 2.1870288765057921e-4 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 ] , [ 0.0 , 0.0 , 9.510891977697611e-4 , 4.150509194005281e-4 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 ] , [ 0.0 , 0.0 , 0.0 , 4.035891906823963e-4 , 5.276656011119485e-4 , 2.574124082457274e-4 , 0.0 , 0.0 , 0.0 , 0.0 ] , [ 0.0 , 0.0 , 0.0 , 0.0 , 7.329034269787371e-5 , 2.342205698369071e-4 , 3.8295105332508683e-4 , 2.8712040511891246e-4 , 1.9128978601656854e-4 , 9.545915963826701e-5 ] ] &gt;","ref":"NxSignal.html#mel_filters/4","title":"NxSignal.mel_filters/4","type":"function"},{"doc":"Performs the overlap-and-add algorithm over an M by N tensor, where M is the number of windows and N is the window size. The tensor is zero-padded on the right so the last window fully appears in the result. Options :overlap_length - The number of overlapping samples between windows :type - output type for casting the accumulated result. If not given, defaults to Nx.Type.to_complex/1 called on the input type. Examples iex&gt; NxSignal . overlap_and_add ( Nx . iota ( { 3 , 4 } ) , overlap_length : 0 ) # Nx.Tensor &lt; s64 [ 12 ] [ 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 , 11 ] &gt; iex&gt; NxSignal . overlap_and_add ( Nx . iota ( { 3 , 4 } ) , overlap_length : 3 ) # Nx.Tensor &lt; s64 [ 6 ] [ 0 , 5 , 15 , 18 , 17 , 11 ] &gt;","ref":"NxSignal.html#overlap_and_add/2","title":"NxSignal.overlap_and_add/2","type":"function"},{"doc":"Computes the Short-Time Fourier Transform of a tensor. Returns the complex spectrum Z, the time in seconds for each frame and the frequency bins in Hz. The STFT is parameterized through: $k$: length of the Discrete Fourier Transform (DFT) $N$: length of each frame $H$: hop (in samples) between frames (calculated as $H = N - \\text{overlap\\_length}$) $M$: number of frames $x[n]$: the input time-domain signal $w[n]$: the window function to be applied to each frame $$ DFT(x, w) := \\sum_{n=0}^{N - 1} x[n]w[n]e^\\frac{-2 \\pi i k n}{N} \\\\ X[m, k] = DFT(x[mH..(mH + N - 1)], w) $$ where $m$ assumes all values in the interval $[0, M - 1]$ See also: NxSignal.Windows , istft/3 , stft_to_mel/3 Options :sampling_rate - the sampling frequency $F_s$ for the input in Hz. Defaults to 1000 . :fft_length - the DFT length that will be passed to Nx.fft/2 . Defaults to :power_of_two . :overlap_length - the number of samples for the overlap between frames. Defaults to half the window size. :window_padding - :reflect , :zeros or nil . See as_windowed/3 for more details. :scaling - nil , :spectrum or :psd . :spectrum - each frame is divided by $\\sum_{i} window[i]$. nil - No scaling is applied. :psd - each frame is divided by $\\sqrt{F_s\\sum_{i} window[i]^2}$. Examples iex&gt; { z , t , f } = NxSignal . stft ( Nx . iota ( { 4 } ) , NxSignal.Windows . rectangular ( n : 2 ) , overlap_length : 1 , fft_length : 2 , sampling_rate : 400 ) iex&gt; z # Nx.Tensor &lt; c64 [ frames : 3 ] [ frequencies : 2 ] [ [ 1.0 + 0.0 i , - 1.0 + 0.0 i ] , [ 3.0 + 0.0 i , - 1.0 + 0.0 i ] , [ 5.0 + 0.0 i , - 1.0 + 0.0 i ] ] &gt; iex&gt; t # Nx.Tensor &lt; f32 [ frames : 3 ] [ 0.0024999999441206455 , 0.004999999888241291 , 0.007499999832361937 ] &gt; iex&gt; f # Nx.Tensor &lt; f32 [ frequencies : 2 ] [ 0.0 , 200.0 ] &gt;","ref":"NxSignal.html#stft/3","title":"NxSignal.stft/3","type":"function"},{"doc":"Converts a given STFT time-frequency spectrum into a MEL-scale time-frequency spectrum. See also: stft/3 , istft/3 , mel_filters/4 Arguments z - STFT spectrum sampling_rate - Sampling frequency in Hz Options :fft_length - Number of FFT bins :mel_bins - Number of target MEL bins. Defaults to 128 :type - Target output type. Defaults to {:f, 32} Examples iex&gt; fft_length = 16 iex&gt; sampling_rate = 8.0e3 iex&gt; { z , _ , _ } = NxSignal . stft ( Nx . iota ( { 10 } ) , NxSignal.Windows . hann ( n : 4 ) , overlap_length : 2 , fft_length : fft_length , sampling_rate : sampling_rate , window_padding : :reflect ) iex&gt; Nx . axis_size ( z , :frequencies ) 16 iex&gt; Nx . axis_size ( z , :frames ) 5 iex&gt; NxSignal . stft_to_mel ( z , sampling_rate , fft_length : fft_length , mel_bins : 4 ) # Nx.Tensor &lt; f32 [ frames : 5 ] [ mel : 4 ] [ [ 0.2900530695915222 , 0.17422175407409668 , 0.18422472476959229 , 0.09807997941970825 ] , [ 0.6093881130218506 , 0.5647397041320801 , 0.4353824257850647 , 0.08635270595550537 ] , [ 0.7584103345870972 , 0.7085014581680298 , 0.5636920928955078 , 0.179118812084198 ] , [ 0.8461772203445435 , 0.7952491044998169 , 0.6470762491226196 , 0.2520409822463989 ] , [ 0.908548891544342 , 0.8572604656219482 , 0.7078656554222107 , 0.3086767792701721 ] ] &gt;","ref":"NxSignal.html#stft_to_mel/3","title":"NxSignal.stft_to_mel/3","type":"function"},{"doc":"Common filter functions.","ref":"NxSignal.Filters.html","title":"NxSignal.Filters","type":"module"},{"doc":"Calculates the normalized sinc function $sinc(t) = \\frac{sin(\\pi t)}{\\pi t}$ Examples iex&gt; NxSignal.Filters . sinc ( Nx . tensor ( [ 0 , 0.25 , 1 ] ) ) # Nx.Tensor &lt; f32 [ 3 ] [ 1.0 , 0.9003162980079651 , - 2.7827534054836178e-8 ] &gt;","ref":"NxSignal.Filters.html#sinc/1","title":"NxSignal.Filters.sinc/1","type":"function"},{"doc":"Common window functions.","ref":"NxSignal.Windows.html","title":"NxSignal.Windows","type":"module"},{"doc":"Bartlett triangular window. See also: triangular/1 Options :n - The window length. Mandatory option. :type - the output type for the window. Defaults to {:f, 32} :name - the axis name. Defaults to nil Examples iex&gt; NxSignal.Windows . bartlett ( n : 3 ) # Nx.Tensor &lt; f32 [ 3 ] [ 0.0 , 0.6666666865348816 , 0.6666666269302368 ] &gt;","ref":"NxSignal.Windows.html#bartlett/1","title":"NxSignal.Windows.bartlett/1","type":"function"},{"doc":"Blackman window. Options :n - The window length. Mandatory option. :is_periodic - If true , produces a periodic window, otherwise produces a symmetric window. Defaults to true :type - the output type for the window. Defaults to {:f, 32} :name - the axis name. Defaults to nil Examples iex&gt; NxSignal.Windows . blackman ( n : 5 , is_periodic : false ) # Nx.Tensor &lt; f32 [ 5 ] [ - 1.4901161193847656e-8 , 0.3400000333786011 , 0.9999999403953552 , 0.3400000333786011 , - 1.4901161193847656e-8 ] &gt; iex&gt; NxSignal.Windows . blackman ( n : 5 , is_periodic : true ) # Nx.Tensor &lt; f32 [ 5 ] [ - 1.4901161193847656e-8 , 0.20077012479305267 , 0.8492299318313599 , 0.8492299318313599 , 0.20077012479305267 ] &gt; iex&gt; NxSignal.Windows . blackman ( n : 6 , is_periodic : true , type : { :f , 32 } ) # Nx.Tensor &lt; f32 [ 6 ] [ - 1.4901161193847656e-8 , 0.12999999523162842 , 0.6299999952316284 , 0.9999999403953552 , 0.6299999952316284 , 0.12999999523162842 ] &gt;","ref":"NxSignal.Windows.html#blackman/1","title":"NxSignal.Windows.blackman/1","type":"function"},{"doc":"Hamming window. Options :n - The window length. Mandatory option. :is_periodic - If true , produces a periodic window, otherwise produces a symmetric window. Defaults to true :type - the output type for the window. Defaults to {:f, 32} :name - the axis name. Defaults to nil Examples iex&gt; NxSignal.Windows . hamming ( n : 5 , is_periodic : true ) # Nx.Tensor &lt; f32 [ 5 ] [ 0.08000001311302185 , 0.39785221219062805 , 0.9121478796005249 , 0.9121478199958801 , 0.3978521227836609 ] &gt; iex&gt; NxSignal.Windows . hamming ( n : 5 , is_periodic : false ) # Nx.Tensor &lt; f32 [ 5 ] [ 0.08000001311302185 , 0.5400000214576721 , 1.0 , 0.5400000214576721 , 0.08000001311302185 ] &gt;","ref":"NxSignal.Windows.html#hamming/1","title":"NxSignal.Windows.hamming/1","type":"function"},{"doc":"Hann window. Options :n - The window length. Mandatory option. :is_periodic - If true , produces a periodic window, otherwise produces a symmetric window. Defaults to true :type - the output type for the window. Defaults to {:f, 32} :name - the axis name. Defaults to nil Examples iex&gt; NxSignal.Windows . hann ( n : 5 , is_periodic : false ) # Nx.Tensor &lt; f32 [ 5 ] [ 0.0 , 0.5 , 1.0 , 0.5 , 0.0 ] &gt; iex&gt; NxSignal.Windows . hann ( n : 5 , is_periodic : true ) # Nx.Tensor &lt; f32 [ 5 ] [ 0.0 , 0.34549152851104736 , 0.9045085310935974 , 0.9045084714889526 , 0.3454914391040802 ] &gt;","ref":"NxSignal.Windows.html#hann/1","title":"NxSignal.Windows.hann/1","type":"function"},{"doc":"Rectangular window. Useful for when no window function should be applied. Options :n - the window length :type - the output type. Defaults to s64 Examples iex&gt; NxSignal.Windows . rectangular ( n : 5 ) # Nx.Tensor &lt; s64 [ 5 ] [ 1 , 1 , 1 , 1 , 1 ] &gt; iex&gt; NxSignal.Windows . rectangular ( n : 5 , type : :f32 ) # Nx.Tensor &lt; f32 [ 5 ] [ 1.0 , 1.0 , 1.0 , 1.0 , 1.0 ] &gt;","ref":"NxSignal.Windows.html#rectangular/1","title":"NxSignal.Windows.rectangular/1","type":"function"},{"doc":"Triangular window. See also: bartlett/1 Options :n - The window length. Mandatory option. :type - the output type for the window. Defaults to {:f, 32} :name - the axis name. Defaults to nil Examples iex&gt; NxSignal.Windows . triangular ( n : 3 ) # Nx.Tensor &lt; f32 [ 3 ] [ 0.5 , 1.0 , 0.5 ] &gt;","ref":"NxSignal.Windows.html#triangular/1","title":"NxSignal.Windows.triangular/1","type":"function"},{"doc":"Mix . install ( [ { :nx_signal , &quot;~&gt; 0.5&quot; , github : &quot;elixir-nx/nx_signal&quot; } , { :vega_lite , &quot;~&gt; 0.1&quot; } , { :kino_vega_lite , &quot;~&gt; 0.1&quot; } ] )","ref":"filtering.html","title":"Filtering","type":"extras"},{"doc":"fs = 16.0e3 window_duration_seconds = 100.0e-3 window_length = 2 * * ceil ( :math . log2 ( fs * window_duration_seconds ) ) signal_duration_seconds = 3 signal_length = ceil ( signal_duration_seconds * fs ) sin = fn freq , n -&gt; Nx . sin ( Nx . multiply ( 2 * :math . pi ( ) * freq / fs , n ) ) end half_n = Nx . iota ( { div ( signal_length , 2 ) } ) sin220 = sin . ( 220 , half_n ) sin440 = sin . ( 440 , half_n ) sin1000 = sin . ( 440 * 5 / 2 , half_n ) sin3000 = sin . ( 220 * 4 / 3 * 4 , half_n ) n = Nx . iota ( { signal_length } ) t = Nx . divide ( n , fs ) data = Nx . concatenate ( [ Nx . add ( sin440 , sin1000 ) , Nx . add ( sin220 , sin3000 ) ] ) # Data for plotting slice = ( signal_length - 3000 ) .. ( signal_length - 2750 ) plot_data = %{ y : Nx . to_flat_list ( data [ [ slice ] ] ) , x : Nx . to_flat_list ( t [ [ slice ] ] ) } VegaLite . new ( width : 600 , height : 400 , title : &quot;Signal sample&quot; ) |&gt; VegaLite . data_from_values ( plot_data , only : [ &quot;x&quot; , &quot;y&quot; ] ) |&gt; VegaLite . mark ( :line ) |&gt; VegaLite . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; VegaLite . encode_field ( :y , &quot;y&quot; , type : :quantitative )","ref":"filtering.html#prepare-the-data","title":"Filtering - Prepare the data","type":"extras"},{"doc":"# The filter used is a simple ideal filter specified through sinc # Cutoff frequency in Hz fc = 600 filter_indices = Nx . iota ( { window_length } ) |&gt; Nx . subtract ( div ( window_length , 2 ) ) h_ideal = Nx . multiply ( 2 * fc / fs , NxSignal.Filters . sinc ( Nx . multiply ( 2 * fc / fs , filter_indices ) ) ) window = NxSignal.Windows . hann ( n : window_length ) h = Nx . multiply ( h_ideal , window ) hfft = h |&gt; Nx . fft ( length : window_length ) |&gt; Nx . abs ( ) |&gt; Nx . add ( 1.0e-10 ) hfft_power = hfft |&gt; Nx . log ( ) |&gt; Nx . divide ( Nx . log ( 10 ) ) |&gt; Nx . multiply ( 20 ) f_idx = Nx . iota ( { window_length } ) |&gt; Nx . subtract ( div ( window_length , 2 ) ) f = Nx . multiply ( f_idx , fs / window_length ) plot_data = %{ n : Enum . to_list ( 0 .. ( window_length - 1 ) ) , h : Nx . to_flat_list ( h ) , hfft : Nx . to_flat_list ( Nx . take_along_axis ( hfft_power , Nx . select ( Nx . less ( f_idx , 0 ) , Nx . add ( f_idx , window_length ) , f_idx ) ) ) , f : Nx . to_flat_list ( f ) } VegaLite . new ( width : 600 , height : 400 , title : &quot;600 Hz Low-Pass filter (Hann window); L = 2048&quot; ) |&gt; VegaLite . data_from_values ( plot_data , only : [ &quot;n&quot; , &quot;h&quot; ] ) |&gt; VegaLite . mark ( :line ) |&gt; VegaLite . encode_field ( :x , &quot;n&quot; , type : :quantitative ) |&gt; VegaLite . encode_field ( :y , &quot;h&quot; , type : :quantitative ) VegaLite . new ( width : 600 , height : 400 , title : &quot;FFT - 1200 Hz Low-Pass filter (Hann window); L = 1764&quot; ) |&gt; VegaLite . data_from_values ( plot_data , only : [ &quot;f&quot; , &quot;hfft&quot; ] ) |&gt; VegaLite . mark ( :line ) |&gt; VegaLite . encode_field ( :x , &quot;f&quot; , type : :quantitative ) |&gt; VegaLite . encode_field ( :y , &quot;hfft&quot; , type : :quantitative )","ref":"filtering.html#preparing-the-filter","title":"Filtering - Preparing the Filter","type":"extras"},{"doc":"# Now that we have our filter, instead of convolving the filter # with the time representation of the signal, we can multiply each # STFT frame by the DFT of the filter (represented by hfft) { z , t , f } = NxSignal . stft ( data , window , fft_length : window_length , sampling_rate : fs , scaling : :spectrum ) # Filter z_filtered = Nx . multiply ( z , hfft ) max_f = Nx . select ( Nx . greater_equal ( f , fs / 2 ) , Nx . iota ( f . shape ) , Nx . size ( f ) + 1 ) |&gt; Nx . argmin ( ) |&gt; Nx . to_number ( ) spectrogram = z |&gt; Nx . slice ( [ 0 , 0 ] , [ Nx . size ( t ) , max_f ] ) |&gt; Nx . abs ( ) |&gt; Nx . pow ( 2 ) filtered_spectrogram = z_filtered |&gt; Nx . slice ( [ 0 , 0 ] , [ Nx . size ( t ) , max_f ] ) |&gt; Nx . abs ( ) |&gt; Nx . pow ( 2 ) # Reconstruct the time signal data_out = z_filtered |&gt; NxSignal . istft ( window , fft_length : window_length , scaling : :spectrum , sampling_rate : fs ) |&gt; Nx . as_type ( data . type ) plot_data = for t_idx &lt;- 0 .. ( Nx . size ( t ) - 1 ) , f_idx &lt;- 0 .. max_f , Nx . to_number ( f [ [ f_idx ] ] ) &lt;= 4000 , reduce : %{ &quot;t&quot; =&gt; [ ] , &quot;f&quot; =&gt; [ ] , &quot;s&quot; =&gt; [ ] , &quot;filtered_s&quot; =&gt; [ ] } do %{ &quot;t&quot; =&gt; t_acc , &quot;f&quot; =&gt; f_acc , &quot;s&quot; =&gt; s_acc , &quot;filtered_s&quot; =&gt; filtered_s_acc } -&gt; %{ &quot;t&quot; =&gt; [ Nx . to_number ( t [ [ t_idx ] ] ) | t_acc ] , &quot;f&quot; =&gt; [ Float . round ( Nx . to_number ( f [ [ f_idx ] ] ) , 3 ) | f_acc ] , &quot;s&quot; =&gt; [ Nx . to_number ( spectrogram [ [ t_idx , f_idx ] ] ) | s_acc ] , &quot;filtered_s&quot; =&gt; [ Nx . to_number ( filtered_spectrogram [ [ t_idx , f_idx ] ] ) | filtered_s_acc ] } end defmodule Spectrogram do alias VegaLite , as : Vl def plot ( title , dataset ) do Vl . new ( title : title , width : 500 , height : 500 ) |&gt; Vl . mark ( :rect ) |&gt; Vl . data_from_values ( dataset ) |&gt; Vl . encode_field ( :x , &quot;t&quot; , type : :quantitative , title : &quot;Time (seconds)&quot; , axis : [ tick_min_step : 0.1 ] , grid : false ) |&gt; Vl . encode_field ( :y , &quot;f&quot; , type : :quantitative , sort : &quot;-x&quot; , title : &quot;Frequency (Hz)&quot; , axis : [ tick_count : 25 ] , grid : false ) |&gt; Vl . encode_field ( :color , &quot;s&quot; , aggregate : :max , type : :quantitative , scale : [ scheme : &quot;viridis&quot; ] , legend : [ title : &quot;dBFS&quot; ] ) |&gt; Vl . config ( view : [ stroke : nil ] ) end end Spectrogram . plot ( &quot;Spectrogram&quot; , Map . take ( plot_data , [ &quot;t&quot; , &quot;f&quot; , &quot;s&quot; ] ) ) Spectrogram . plot ( &quot;Filtered Spectrogram&quot; , Map . take ( plot_data , [ &quot;t&quot; , &quot;f&quot; ] ) |&gt; Map . put ( &quot;s&quot; , plot_data [ &quot;filtered_s&quot; ] ) ) plot_data = %{ y : Nx . to_flat_list ( data_out [ [ slice ] ] ) , x : Nx . to_flat_list ( Nx . divide ( n , fs ) [ [ slice ] ] ) } VegaLite . new ( width : 600 , height : 400 , title : &quot;Reconstructed Signal&quot; ) |&gt; VegaLite . data_from_values ( plot_data , only : [ &quot;x&quot; , &quot;y&quot; ] ) |&gt; VegaLite . mark ( :line ) |&gt; VegaLite . encode_field ( :x , &quot;x&quot; , type : :quantitative ) |&gt; VegaLite . encode_field ( :y , &quot;y&quot; , type : :quantitative ) As we can see, the same original slice is now a pure 220Hz sine wave, because we got rid of the higher frequency harmonic.","ref":"filtering.html#filtering-the-data","title":"Filtering - Filtering the data","type":"extras"},{"doc":"Mix . install ( [ { :nx_signal , &quot;&gt;= 0.0.0&quot; , github : &quot;polvalente/nx-signal&quot; } , { :vega_lite , &quot;~&gt; 0.1.4&quot; } , { :kino_vega_lite , &quot;~&gt; 0.1.1&quot; } ] )","ref":"spectrogram.html","title":"Spectrogram Plotting","type":"extras"},{"doc":"# You can load an audio file here. For this example, # we&#39;re producing 3 seconds of 220Hz, 440Hz, 1kHz and 3kHz sine waves fs = 44.1e3 t_max = 3 full_n = ceil ( fs * t_max ) half_n = div ( full_n , 2 ) # samples/sec * sec = samples n = Nx . iota ( { half_n } ) sin = fn freq , n -&gt; Nx . sin ( Nx . multiply ( 2 * :math . pi ( ) * freq / fs , n ) ) end sin220 = sin . ( 220 , n ) sin440 = sin . ( 440 , n ) sin1000 = sin . ( 1000 , n ) sin3000 = sin . ( 3000 , n ) data = Nx . concatenate ( [ Nx . add ( sin440 , sin1000 ) , Nx . add ( sin220 , sin3000 ) ] ) n = Nx . iota ( { full_n } ) d = %{ data : Nx . to_flat_list ( data [ [ 1000 .. 1250 ] ] ) , n : Nx . to_flat_list ( n [ [ 1000 .. 1250 ] ] ) } VegaLite . new ( width : 600 , height : 600 , title : &quot;Audio Sample&quot; ) |&gt; VegaLite . data_from_values ( d , only : [ &quot;n&quot; , &quot;data&quot; ] ) |&gt; VegaLite . mark ( :line ) |&gt; VegaLite . encode_field ( :x , &quot;n&quot; , type : :ordinal ) |&gt; VegaLite . encode_field ( :y , &quot;data&quot; , type : :quantitative ) defmodule Spectrogram do alias VegaLite , as : Vl import Nx.Defn def calculate_stft_and_plot_spectrogram ( input , fs , window_duration_ms , plot_cutoff_frequency \\\\ 4000 ) do n_window = ceil ( fs * window_duration_ms ) { spectrogram , f , t , max_f } = stft ( input , fs : fs , n_window : n_window ) max_f = Nx . to_number ( max_f ) spectrogram = Nx . slice ( spectrogram , [ 0 , 0 ] , [ Nx . size ( t ) , max_f ] ) f = Nx . slice ( f , [ 0 ] , [ max_f ] ) spectrogram |&gt; to_plot_data ( f , t , plot_cutoff_frequency ) |&gt; plot ( ) end defn stft ( input , opts ) do fs = opts [ :fs ] n_window = opts [ :n_window ] # ms to samples window = NxSignal.Windows . hann ( n : n_window , is_periodic : true ) # use the default overlap of 50% { s , t , f } = NxSignal . stft ( input , window , sampling_rate : fs , fft_length : 1024 ) max_f = Nx . select ( f &gt;= fs / 2 , Nx . iota ( f . shape ) , Nx . size ( f ) + 1 ) |&gt; Nx . argmin ( ) spectrogram = Nx . abs ( s ) # to dBFS spectrogram = 20 * Nx . log ( spectrogram / Nx . reduce_max ( spectrogram ) ) / Nx . log ( 10 ) { spectrogram , f , t , max_f } end defp to_plot_data ( s , f , t , plot_cutoff_frequency ) do for t_idx &lt;- 0 .. ( Nx . size ( t ) - 1 ) , f_idx &lt;- 0 .. ( Nx . size ( f ) - 1 ) , Nx . to_number ( f [ [ f_idx ] ] ) &lt;= plot_cutoff_frequency , reduce : %{ &quot;t&quot; =&gt; [ ] , &quot;f&quot; =&gt; [ ] , &quot;s&quot; =&gt; [ ] } do %{ &quot;t&quot; =&gt; t_acc , &quot;f&quot; =&gt; f_acc , &quot;s&quot; =&gt; s_acc } -&gt; %{ &quot;t&quot; =&gt; [ Nx . to_number ( t [ [ t_idx ] ] ) | t_acc ] , &quot;f&quot; =&gt; [ Float . round ( Nx . to_number ( f [ [ f_idx ] ] ) , 3 ) | f_acc ] , &quot;s&quot; =&gt; [ Nx . to_number ( s [ [ t_idx , f_idx ] ] ) | s_acc ] } end end defp plot ( dataset ) do Vl . new ( title : &quot;Spectrogram&quot; , width : 500 , height : 500 ) |&gt; Vl . mark ( :rect ) |&gt; Vl . data_from_values ( dataset ) |&gt; Vl . encode_field ( :x , &quot;t&quot; , type : :quantitative , title : &quot;Time (seconds)&quot; , axis : [ tick_min_step : 0.1 ] , grid : false ) |&gt; Vl . encode_field ( :y , &quot;f&quot; , type : :quantitative , sort : &quot;-x&quot; , title : &quot;Frequency (Hz)&quot; , axis : [ tick_count : 25 ] , grid : false ) |&gt; Vl . encode_field ( :color , &quot;s&quot; , aggregate : :max , type : :quantitative , scale : [ scheme : &quot;viridis&quot; ] , legend : [ title : &quot;dBFS&quot; ] ) |&gt; Vl . config ( view : [ stroke : nil ] ) end end Spectrogram . calculate_stft_and_plot_spectrogram ( data , fs , 50.0e-3 ) Notice how the first half of the spectrogram looks cleaner than the second one. This is due to the window length, that also interferes in how we can observe both our time and frequency resolutions. Below we can see what happens if we use different window durations (150ms, 100ms and 25ms respectively). Spectrogram . calculate_stft_and_plot_spectrogram ( data , fs , 150.0e-3 ) Spectrogram . calculate_stft_and_plot_spectrogram ( data , fs , 100.0e-3 ) Spectrogram . calculate_stft_and_plot_spectrogram ( data , fs , 25.0e-3 )","ref":"spectrogram.html#generating-the-audio-data","title":"Spectrogram Plotting - Generating the audio data","type":"extras"}]